#ifndef morpheo_behavioural_core_multi_front_end_front_end_decod_unit_decod_Parameters_h
#define morpheo_behavioural_core_multi_front_end_front_end_decod_unit_decod_Parameters_h

/*
 * $Id: Parameters.h 86 2008-05-14 17:08:56Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Common/include/Debug.h"
#include "Behavioural/include/Parameters.h"
#include "Behavioural/include/Types.h"
#include "Behavioural/Custom/include/Custom.h"
#include "Behavioural/Custom/include/Custom_default.h"

namespace morpheo {
namespace behavioural {
namespace core {
namespace multi_front_end {
namespace front_end {
namespace decod_unit {
namespace decod {

  class Parameters : public morpheo::behavioural::Parameters
  {
    //-----[ fields ]------------------------------------------------------------
  public : uint32_t            _nb_context                   ;
  public : uint32_t          * _nb_inst_fetch                ; //[nb_context]
  public : uint32_t            _nb_inst_decod                ;
  public : uint32_t            _size_general_data            ;
  public : uint32_t            _nb_branch_speculated         ;
  public : uint32_t            _size_branch_update_prediction;
  public : uint32_t            _nb_context_select            ;
  public : Tpriority_t         _priority                     ;
  public : Tload_balancing_t   _load_balancing               ;
  public : bool             ** _instruction_implemeted       ; //[nb_context][nb_instruction]
  public : morpheo::behavioural::custom::custom_information_t (*_get_custom_information) (uint32_t);
    
  public : uint32_t            _max_nb_inst_fetch     ;

  public : uint32_t            _size_address_inst     ;
  public : uint32_t            _size_context_id       ;
  public : uint32_t            _size_depth            ;
  public : uint32_t            _size_inst_ifetch_ptr  ;
						      
  public : bool                _have_port_context_id                 ;
  public : bool                _have_port_depth                      ;
  public : bool                _have_port_branch_update_prediction_id;
  public : bool                _have_port_inst_ifetch_ptr            ;

    //-----[ methods ]-----------------------------------------------------------

  public : Parameters  (uint32_t            nb_context                   ,
			uint32_t          * nb_inst_fetch                ,
			uint32_t            nb_inst_decod                ,
			uint32_t            size_general_data            ,
			uint32_t            nb_branch_speculated         ,
			uint32_t            size_branch_update_prediction,
			uint32_t            nb_context_select            ,
			Tpriority_t         priority                     ,
			Tload_balancing_t   load_balancing               ,
			bool             ** instruction_implemeted       ,
			morpheo::behavioural::custom::custom_information_t (*get_custom_information) (uint32_t));

//   public : Parameters  (Parameters & param) ;
  public : ~Parameters () ;

  public :        Parameters_test msg_error  (void);

  public :        std::string     print      (uint32_t depth);
  public : friend std::ostream&   operator<< (std::ostream& output_stream,
					      morpheo::behavioural::core::multi_front_end::front_end::decod_unit::decod::Parameters & x);
  };

}; // end namespace decod
}; // end namespace decod_unit
}; // end namespace front_end
}; // end namespace multi_front_end
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              

#endif
